module.exports = function(grunt) {
    grunt.initConfig({
        pkg: grunt.file.readJSON('package.json'),
        tocdoc: {
            options: {
                cssFilePath: '../html/styles.css',
                cssUrl: 'styles.css'
            },
            docSite: {
                files: [
                    {
                        '../html/index.html': ['docs/*.md']
                    },
                    {
                        '../html/examples.html': ['examples/*.md']
                    }
                ]
            }
        },
        replace: {
            dist: {
                src: ['../html/*.html'],
                overwrite: true,
                replacements: [{
                    from: '<link rel="stylesheet" type="text/css" href="styles.css" />',
                    to: '<link rel="stylesheet" type="text/css" href="styles.css" /><link rel="stylesheet" type="text/css" href="custom.css" />'
                }]
            }
        },

        'string-replace': {
            inline: {
                files: [{
                    expand: true,
                    cwd: '../html/',
                    src: '**/*.html',
                    dest: '../html/'
                }],
                options: {
                    replacements: [
                        // place files inline example
                        {
                            pattern: '<body>',
                            replacement: '<body><%= grunt.file.read("inc/header.html") %></body>'
                        }
                    ]
                }
            }
        },

        copy: {
            dist: {
                files: [
                    {
                        expand: true,
                        dot: true,
                        cwd: 'images/',
                        dest: '../html/images/',
                        src: ['**/*']
                    },
                    {
                        expand: true,
                        dot: true,
                        src: 'custom.css',
                        flatten: true,
                        dest: '../html/'
                    }
                ]
            }
        }
    });

    grunt.loadNpmTasks('grunt-tocdoc');
    grunt.loadNpmTasks('grunt-contrib-copy');
    grunt.loadNpmTasks('grunt-text-replace');
    grunt.loadNpmTasks('grunt-string-replace');

    grunt.registerTask('default', ['tocdoc', 'copy', 'replace', 'string-replace']);
};