## Add Tag

This will validate an form, normally placed just above a form.

### The tag
```javascript
{exp:forms_js_validation:add}
```

### Tag parameters
Below are the Tag Parameters. Those parameters can be used in the tag described above.

#### selector
Set the selector for your form

```javascript
selector="" 
```

#### input_element_wrapper
Set the main class of the wrapper which surround your input

```javascript
input_element_wrapper=".control-group"
```

#### promt_position
Set the position for the promt message. Possible options `top-left` `top-right` `bottom-left` `center-right` `bottom-right`

```javascript
promt_position=""
```

#### require_class
a class name for the require input fields. `<input class="required"/>`

```javascript
require_class="" (without a dot)
```

#### email_class
a class name for the require email input fields `<input class="email_class"/>`

```javascript
email_class="" (without a dot)	
```

#### group_class
At least one of the field of the group must be filled. It needs to be given a group name that is unique across the form. '[group_class]:[group_name]' `<input class="group:payments"/>`

```javascript
group_class="" (without a dot)	
```

#### min_class
Validates when the field's value is less than, or equal to, the given parameter. '[min_class]:[min_value]' `<input class="min:5"/>`

```javascript
min_class="" (without a dot)
```

#### max_class
Validates when the field's value is more than, or equal to, the given parameter. '[max_class]:[max_value]' `<input class="max:15"/>`

```javascript
max_class="" (without a dot)
```

#### min_size_class
Validates if the element content size (in characters) is more than, or equal to, the given integer. '[min_size_class]:[min_size_value]' `<input class="min_size:5"/>`

```javascript
min_size_class="" (without a dot)
```

#### max_size_class
Validates if the element content size (in characters) is less than, or equal to, the given integer. '[max_size_class]:[max_size_value]' `<input class="max_size:5"/>`

```javascript
max_size_class="" (without a dot)
```

#### integer_class
Validates if the field is a integer, with an optional sign. ie. -635 +2201 738  `<input class="val_integer"/>`

```javascript
integer_class="" (without a dot)
```

#### number_class
Floating points with an optional sign. ie. -143.22 or .77 but also +234,23 `<input class="val_number"/>`

```javascript
number_class="" (without a dot)	
```

#### phone_class
a typical phone number with an optional country code and extension. Note that the validation is relaxed. `<input class="val_phone"/>`

```javascript
phone_class="" (without a dot)
```

#### url_class
Matches a URL such as http://myserver.com, https://www.crionics.com or ftp://myserver.ws `<input class="val_url"/>`

```javascript
url_class="validation_url" (without a dot)
```

#### date_class
An ISO date, YYYY-MM-DD `<input class="val_date"/>`

```javascript
date_class="" (without a dot)
```

#### ipv4_class
An IP address (v4) ie. 127.0.0.1 `<input class="val_ip"/>`

```javascript
ipv4_class="" (without a dot)
```

#### equals_class
Match an field with an other `<input class="equals:field_12"/>`

```javascript
equals_class="" (without a dot)
```

#### past_class
Checks if the element's value (which is implicitly a date) is earlier than the given date.
When "NOW" is used as a parameter, the date will be calculate in the browser.
When a "#field name" is used ( The '#' is optional ), it will compare the element's value with another element's value within the same form.
Note that this may be different from the server date. Dates use the ISO format YYYY-MM-DD `<input class="date past:now"/>`

```javascript
past_class="validation_past" (without a dot)
```

#### future_class
Checks if the element's value (which is implicitly a date) is greater than the given date.
When "NOW" is used as a parameter, the date will be calculate in the browser.
When a "#field name" is used ( The '#' is optional ), it will compare the element's value with another element's value within the same form. Note that this may be different from the server date.
Dates use the ISO format YYYY-MM-DD `<input class="date future:now"/>`

```javascript
future_class="validation_future" (without a dot)
```

#### creditcard_class
Validates that a credit card number is at least theoretically valid, according the to the Luhn checksum algorithm, but not whether the specific card number is active with a bank, etc. `<input class="val_creditcard"/>`

```javascript
creditcard_class="" (without a dot)
```

#### validation_condition
This makes the field required, but only if any of the referred fields has a value. `<input class="condition:field10"/>`

```javascript
condition_class="validation_condition" (without a dot)
```