## Javascript Callbacks

When ajaxFormValidation is turned on, this is the function that will be called before the asynchronous AJAX form validation call. May return false to stop the Ajax form validation

```javascript
onBeforeAjaxFormValidation(form, options)
```

When ajaxFormValidation is turned on, this function is used to asynchronously process the result of the validation. the status is a boolean. If true, the ajax call completed and all the server side form validations passed.

```
onAjaxFormComplete(status, form, errors, options)
```

When onValidationComplete defined, it stops by default the form from auto-submitting, and lets you handle the validation status via a function. You can also return true in this function and the form will be allowed to submit.

```
onValidationComplete: function(form, status)
```

If onSuccess is set, this callback function will be called when all validations passed.

```
onSuccess : function()
```

If onFailure is set, this callback function will be called when it found an error.

```
onFailure: function()

```

#### Example usage
```
{exp:forms_js_validation
  selector=".test"
  input_element_wrapper=".control-group"
}

<script>
  JS_FORMS.addCallbackEvent('onBeforeAjaxFormValidation', '{count}', function(form, options){
    console.log(form, options);
  });
<script>

{/exp:forms_js_validation}
```
**Notice the `{count}` var. This is required because the plugin will store the callback temporarily to match the correct form.**