/*global module:false*/
module.exports = function(grunt) {

    'use strict';

    // Project configuration.
    grunt.initConfig({
        pkg: grunt.file.readJSON('package.json'),

        meta : {
            banner : '/*!\n' +
            ' * Forms JS Validation.js\n' +
            ' * <%= pkg.homepage %>\n' +
            ' *\n' +
            ' * Copyright <%= grunt.template.today("yyyy") %>, <%= pkg.author %>\n' +
            ' * Released under the <%= pkg.license %> License.\n' +
            ' */\n\n'
        },

        concat: {
            options: {
                banner: '<%= meta.banner %>'
            },
            dist: {
                src: [
                    'js/src/jquery.validationEngine.js',
                    'js/src/jquery.validate.js'
                ],
                dest: 'js/forms_js_validation.js'
            }
        },

        uglify: {
            plugin: {
                src: ["js/forms_js_validation.js"],
                dest: "js/forms_js_validation.min.js"
            },
            options: {
                banner: "<%= meta.banner %>"
            }
        },

        watch : {
            files : '<%= concat.dist.src %>',
            tasks : 'default'
        }
    });

    grunt.loadNpmTasks('grunt-contrib-concat');
    grunt.loadNpmTasks('grunt-contrib-uglify');
    grunt.loadNpmTasks('grunt-contrib-watch');

    grunt.registerTask('default', ['concat', 'uglify']);
};